package com.goafanti.common.dao;

import com.goafanti.common.model.UserMid;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 用户中间表(UserMid)表数据库访问层
 *
 * @author makejava
 * @since 2024-11-20 15:30:19
 */
public interface UserMidMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    UserMid queryById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param userMid  查询条件
     * @param pageable 分页对象
     * @return 对象列表
     */
    List<UserMid> findUserMidList(UserMid userMid, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param userMid 查询条件
     * @return 总行数
     */
    int findUserMidCount(UserMid userMid);

    /**
     * 新增数据
     *
     * @param userMid 实例对象
     * @return 影响行数
     */
    int insert(UserMid userMid);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserMid> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<UserMid> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserMid> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<UserMid> entities);

    /**
     * 修改数据
     *
     * @param userMid 实例对象
     * @return 影响行数
     */
    int update(UserMid userMid);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    int insertSelective(UserMid userMid);
    int updateByUid(UserMid um);

    void updateListByUid(@Param("aid") String aid,@Param("updateFollow") Integer updateFollow, @Param("list")List<String> list);

    String getUserTaskNames(String uid) ;

    UserMid getUserDtails(String buyerId);

    UserMid selectByUid(String uid);

    void updateCallByUid(@Param("uid") String uid, @Param("count") int count, @Param("duration") int duration);
}

